/* MakeObj.CMD                                                              */
/* By: F. Paul Ballard  (716) 425-3471   Compuserve: 70514,24               */
/* Date: 02/25/93                                                           */

Call RxFuncAdd 'SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs';
Call SysLoadFuncs;           

Arg Action ObjectFile

Select
   when Action = "ADD"  then Call AddObject
   when Action = "EDIT" then Call EditObject
   when Action = "HIDE" then Call HideObject
   when Action = "SHOW" then Call ShowObject
end 
exit


AddObject:
   Call GetData
   ReturnCode=SysCreateObject(ClassName,Title,Location,SetupString,'FailIfExists');
   if ReturnCode <> 1 then                 
      Say  "Unable to Create Object."
   else
      Say "Object Created."
   Return

EditObject:
   Call GetData
   ReturnCode=SysCreateObject(ClassName,Title,Location,SetupString,'ReplaceIfExists');
   if ReturnCode <> 1 then                 
      Say  "Unable to Edit Object."
   else
      Say "Object Changed."
   Return

HideObject:
   Call GetData
   SetupString = "NOTVISIBLE=YES;"||SetupString
   ReturnCode=SysCreateObject(ClassName,Title,Location,SetupString,'ReplaceIfExists');
   if ReturnCode <> 1 then                 
      Say  "Unable to Hide Object."
   else
      Say "Object Hidden."
   Return

ShowObject:
   Call GetData
   SetupString = "NOTVISIBLE=NO;"||SetupString
   ReturnCode=SysCreateObject(ClassName,Title,Location,SetupString,'ReplaceIfExists');
   if ReturnCode <> 1 then                 
      Say  "Unable to Show Object."
   else
      Say "Object Shown."
   Return

GetData:   
   do until Lines(ObjectFile) = 0
      DataLine = LineIn(ObjectFile)
      Parse var DataLine KeyName ":" Indicator
      Select
         when KeyName = "CLASSNAME" then ClassName = Indicator
         when KeyName = "TITLE"     then Title = Indicator
         when KeyName = "LOCATION"  then Location = Indicator
         when KeyName = "SETUP"     then SetupString = Indicator
         otherwise Say "Invalid Option In File!"
      end
   end
   Return
